"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withTags = exports.withEmptySearchTerm = exports.withSearchTerm = exports.withoutSearchTerm = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _immutable = require("immutable");

var _presenter = _interopRequireDefault(require("./presenter"));

var props = {
  allInteractions: false,
  showFilters: true,
  toggleFilters: Function.prototype,
  toggleAllInteractions: Function.prototype,
  setFilter: Function.prototype,
  update: Function.prototype,
  toggle: Function.prototype
};
var _default = {
  title: 'BankSearch'
};
exports.default = _default;

var withoutSearchTerm = function withoutSearchTerm() {
  return _react.default.createElement(_presenter.default, Object.assign({}, props, {
    search: (0, _immutable.Map)({
      text: null
    })
  }));
};

exports.withoutSearchTerm = withoutSearchTerm;

var withSearchTerm = function withSearchTerm() {
  return _react.default.createElement(_presenter.default, Object.assign({}, props, {
    search: (0, _immutable.Map)({
      text: 'singlewordsearchstring'
    })
  }));
};

exports.withSearchTerm = withSearchTerm;

var withEmptySearchTerm = function withEmptySearchTerm() {
  return _react.default.createElement(_presenter.default, Object.assign({}, props, {
    search: (0, _immutable.Map)({
      text: ''
    })
  }));
};

exports.withEmptySearchTerm = withEmptySearchTerm;
var tags = [{
  id: '1',
  value: 'Hello'
}, {
  id: '2',
  value: 'World'
}];

var withTags = function withTags() {
  return _react.default.createElement(_presenter.default, Object.assign({}, props, {
    search: (0, _immutable.Map)({
      tags: tags
    })
  }));
};

exports.withTags = withTags;