"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiLayout = require("@instructure/ui-layout");

var _uiA11y = require("@instructure/ui-a11y");

var _uiElements = require("@instructure/ui-elements");

var _quizNumberInput = _interopRequireDefault(require("@instructure/quiz-number-input"));

var _uiButtons = require("@instructure/ui-buttons");

var _uiThemeable = require("@instructure/ui-themeable");

var _uiIcons = require("@instructure/ui-icons");

var _interactionPoints = _interopRequireDefault(require("quiz-interactions/lib/util/interactionPoints"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _EntrySave = _interopRequireDefault(require("../../../../../../common/components/resources/entry/EntrySave"));

var _quizCommon = require("@instructure/quiz-common");

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'kXHyM',
  template: function template(theme) {
    return "\n\n.kXHyM_bVuu{align-items:center;display:inline-flex;flex-wrap:nowrap}\n\n.kXHyM_fsXS,.kXHyM_djwg{align-items:center;display:flex}\n\n.kXHyM_fsXS{margin-left:".concat(theme.feedbackSectionLeftMargin || 'inherit', "}\n\n.kXHyM_duRV{display:inline-flex;font-size:").concat(theme.pointsInputFontSize || 'inherit', ";width:6.1rem}");
  },
  'leftFooter': 'kXHyM_bVuu',
  'feedbackSection': 'kXHyM_fsXS',
  'pointsSection': 'kXHyM_djwg',
  'pointsInput': 'kXHyM_duRV'
};

function pointsAsFloat(pointsString) {
  return parseFloat(pointsString) || 0;
}

function countDecimals(normalizedPointsString) {
  if (!normalizedPointsString) return 0; // eslint-disable-next-line no-unused-vars

  var _normalizedPointsStri = normalizedPointsString.split('.'),
      _normalizedPointsStri2 = (0, _slicedToArray2.default)(_normalizedPointsStri, 2),
      _ = _normalizedPointsStri2[0],
      decimals = _normalizedPointsStri2[1];

  return decimals ? decimals.length : 0;
}

var QuizEntryEditFooter = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(QuizEntryEditFooter, _Component);

  function QuizEntryEditFooter() {
    var _this;

    (0, _classCallCheck2.default)(this, QuizEntryEditFooter);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(QuizEntryEditFooter).apply(this, arguments));
    _this.addFeedbackButton = null;

    _this.openFeedbackModal = function () {
      var workingEntry = _this.props.workingEntry;

      _this.props.setUi(_quizCommon.ITEM_FEEDBACK_MODAL_ITEM, workingEntry);

      _this.props.setUi(_quizCommon.ITEM_FEEDBACK_MODAL_FEEDBACK, workingEntry.feedback);

      _this.props.openModal(_quizCommon.ITEM_FEEDBACK_MODAL, {
        modalTrigger: _this.addFeedbackButton
      });
    };

    _this.handlePointsBlur = function () {
      if (!_this.state.normalizedPoints) {
        _this.setState({
          points: '0'
        });
      }
    };

    _this.handlePointsChange = function (event, points, normalizedPoints) {
      // do not allow more than 3 decimals
      if (countDecimals(normalizedPoints) <= 3) {
        var pointsFloat = pointsAsFloat(normalizedPoints);

        if (pointsFloat !== _this.getPoints()) {
          var _this$props = _this.props,
              workingQuizEntry = _this$props.workingQuizEntry,
              workingEntry = _this$props.workingEntry;
          var qerIndexToUpdate = workingQuizEntry.quizEntryRegrades.findIndex(function (qer) {
            return qer.get('itemId') == workingEntry.id;
          });
          var newQuizEntryRegrades = qerIndexToUpdate > -1 ? workingQuizEntry.quizEntryRegrades.setIn([qerIndexToUpdate, 'pointsPossible'], null) : workingQuizEntry.quizEntryRegrades;

          _this.props.changeQuizEntryPoints(workingQuizEntry.id, pointsFloat, newQuizEntryRegrades.toJS());
        }

        _this.setState({
          points: points,
          normalizedPoints: normalizedPoints
        });
      }
    };

    _this.handleButtonRef = function (node) {
      _this.addFeedbackButton = node;
    };

    var _points = _this.getPoints();

    _this.state = {
      points: _points,
      normalizedPoints: _points
    };
    return _this;
  }

  (0, _createClass2.default)(QuizEntryEditFooter, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var points = this.getPoints(nextProps);
      this.setState({
        points: points,
        normalizedPoints: points
      });
    }
  }, {
    key: "getPoints",
    value: function getPoints() {
      var props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.props;
      var workingQuizEntry = props.workingQuizEntry,
          workingEntry = props.workingEntry;
      return workingQuizEntry.regradeAdjustedPointsPossible(workingEntry.id) || workingQuizEntry.pointsPossible || 0;
    }
  }, {
    key: "pointsDisabled",
    value: function pointsDisabled() {
      var props = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.props;
      var workingEntry = props.workingEntry;
      var pointsFromItem = (0, _interactionPoints.default)(workingEntry.toJS()) !== void 0;
      return pointsFromItem;
    }
  }, {
    key: "renderFeedbackSection",
    value: function renderFeedbackSection() {
      var _this$props2 = this.props,
          entry = _this$props2.entry,
          shouldClone = _this$props2.shouldClone,
          quizEntry = _this$props2.quizEntry,
          workingEntry = _this$props2.workingEntry;
      var disabled = entry.isImmutable() && !shouldClone || quizEntry.isBankEntry;
      var icon, text;

      if (workingEntry.hasFeedback()) {
        icon = _uiIcons.IconDiscussionSolid;
        text = (0, _formatMessage.default)('Edit Item Level Feedback (present)');
      } else {
        icon = _uiIcons.IconDiscussionLine;
        text = (0, _formatMessage.default)('Edit Item Level Feedback');
      }

      return _react.default.createElement("div", {
        className: styles.feedbackSection,
        "data-automation": "sdk-quiz-entry-edit-footer-feedback-section"
      }, _react.default.createElement(_uiButtons.Button, {
        variant: "icon",
        onClick: this.openFeedbackModal,
        disabled: disabled,
        ref: this.handleButtonRef,
        "data-automation": "sdk-open-feedback-modal-button",
        icon: icon
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, text)));
    }
  }, {
    key: "renderPointsSection",
    value: function renderPointsSection() {
      return _react.default.createElement("div", {
        className: styles.pointsSection
      }, _react.default.createElement("span", {
        className: styles.pointsInput
      }, _react.default.createElement(_quizNumberInput.default, {
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Points Possible Input')),
        onChange: this.handlePointsChange,
        onBlur: this.handlePointsBlur,
        value: this.state.points,
        disabled: this.pointsDisabled(),
        "data-automation": "sdk-points-possible-numberinput"
      })), _react.default.createElement(_uiLayout.View, {
        margin: "none none none x-small"
      }, _react.default.createElement(_uiElements.Text, {
        size: "small"
      }, (0, _formatMessage.default)('Points'))));
    }
  }, {
    key: "renderLeftFooter",
    value: function renderLeftFooter() {
      return _react.default.createElement("div", {
        className: styles.leftFooter
      }, this.renderPointsSection(), this.renderFeedbackSection());
    }
  }, {
    key: "renderRightFooter",
    value: function renderRightFooter() {
      if (this.props.alternativeRightFooter) {
        return this.props.alternativeRightFooter();
      }

      return _react.default.createElement(_EntrySave.default, {
        clearChanges: this.props.clearChanges,
        disableSubmit: this.props.disableSubmit,
        displayPosition: this.props.displayPosition,
        entry: this.props.entry,
        guid: this.props.guid,
        isValid: this.props.isValid,
        submitHandler: this.props.successfulSubmit,
        initialFocusId: this.props.initialFocusId
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_uiLayout.View, {
        as: "div",
        background: "light",
        padding: "xx-small none"
      }, _react.default.createElement(_uiLayout.Flex, {
        wrapItems: true,
        justifyItems: "space-between",
        alignItems: "center"
      }, _react.default.createElement(_uiLayout.Flex.Item, {
        padding: "xx-small small"
      }, this.renderLeftFooter()), _react.default.createElement(_uiLayout.Flex.Item, {
        padding: "xx-small small"
      }, this.renderRightFooter())));
    }
  }]);
  QuizEntryEditFooter.displayName = "QuizEntryEditFooter";
  return QuizEntryEditFooter;
}(_react.Component), _class2.propTypes = {
  alternativeRightFooter: _propTypes.default.func,
  changeQuizEntryPoints: _propTypes.default.func.isRequired,
  clearChanges: _propTypes.default.func.isRequired,
  disableSubmit: _propTypes.default.bool,
  displayPosition: _propTypes.default.number.isRequired,
  entry: _reactImmutableProptypes.default.record.isRequired,
  guid: _propTypes.default.string.isRequired,
  initialFocusId: _propTypes.default.string,
  isValid: _propTypes.default.bool.isRequired,
  openModal: _propTypes.default.func.isRequired,
  quizEntry: _reactImmutableProptypes.default.record.isRequired,
  setUi: _propTypes.default.func.isRequired,
  shouldClone: _propTypes.default.bool,
  successfulSubmit: _propTypes.default.func.isRequired,
  workingEntry: _reactImmutableProptypes.default.record.isRequired,
  // This prop is flagged as unused, but it is actually used
  // eslint-disable-next-line react/no-unused-prop-types
  workingQuizEntry: _reactImmutableProptypes.default.record.isRequired
}, _class2.defaultProps = {
  alternativeRightFooter: null,
  disableSubmit: false,
  initialFocusId: null,
  shouldClone: false
}, _temp)) || _class);
exports.default = QuizEntryEditFooter;