"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _uiA11y = require("@instructure/ui-a11y");

var _uiAlerts = require("@instructure/ui-alerts");

var _uiElements = require("@instructure/ui-elements");

var _uiLayout = require("@instructure/ui-layout");

var _uiThemeable = require("@instructure/ui-themeable");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _quizCommon = require("@instructure/quiz-common");

var _FormattedDuration = _interopRequireDefault(require("../../../shared/FormattedDuration"));

var _formatTimespan = require("../../../../util/formatTimespan");

var _theme = _interopRequireDefault(require("./theme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'fhrSa',
  template: function template(theme) {
    return "\n\n.fhrSa_ekHz{align-items:center;display:flex;flex-direction:row;justify-content:center;margin-top:".concat(theme.alertWrapperMargin || 'inherit', "}\n\n.fhrSa_bANW{flex-grow:1;max-width:33rem}\n\n.fhrSa_gasz{margin:none;padding:none}\n\n.fhrSa_pypk,.fhrSa_gasz{align-items:center;display:flex;justify-content:center}\n\n.fhrSa_pypk{align-self:center;flex-wrap:wrap}\n\n.fhrSa_bCqi{flex-wrap:wrap;justify-content:flex-start}\n\n.fhrSa_frHB,.fhrSa_bCqi{align-items:center;display:flex;flex:1 1 auto}\n\n.fhrSa_frHB{height:150px;margin:").concat(theme.scoreMargin || 'inherit', ";width:150px;z-index:").concat(theme.scoreZIndex || 'inherit', "}\n\n.fhrSa_fkZg{font-size:").concat(theme.scorePercentageFontSize || 'inherit', ";font-weight:").concat(theme.scorePercentageFontWeight || 'inherit', "}\n\n.fhrSa_vsBM{flex:1 1 auto;margin:").concat(theme.infoWrapperMargin || 'inherit', ";padding-left:").concat(theme.inforWrapperPadding || 'inherit', "}");
  },
  'alertWrapper': 'fhrSa_ekHz',
  'alertWidth': 'fhrSa_bANW',
  'wrapper': 'fhrSa_gasz',
  'info': 'fhrSa_pypk',
  'scoreStats': 'fhrSa_bCqi',
  'score': 'fhrSa_frHB',
  'scorePercentage': 'fhrSa_fkZg',
  'infoWrapper': 'fhrSa_vsBM'
};
var unknownPercentageValue = 'UNKNOWN_PERCENTAGE';
var Info = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_withI18nSupport) {
  (0, _inherits2.default)(Info, _withI18nSupport);

  function Info(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Info);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Info).call(this, props));
    _this.progressTextFormatter = _this.progressTextFormatter.bind((0, _assertThisInitialized2.default)(_this));
    _this.progressDisplayFormatter = _this.progressDisplayFormatter.bind((0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(Info, [{
    key: "progressTextFormatter",
    // needed for inst-ui Progress
    value: function progressTextFormatter(valueNow, valueMax) {
      var percentageUnknown = valueNow === unknownPercentageValue;
      return percentageUnknown ? (0, _formatMessage.default)('Unknown Score') : (0, _formatMessage.default)('Your score was {percentage}.', {
        percentage: this.formatPercentMax2FractionDigits(valueNow)
      });
    } // needed for inst-ui Progress

  }, {
    key: "progressDisplayFormatter",
    value: function progressDisplayFormatter(valueNow, valueMax) {
      var valueToShow = valueNow === unknownPercentageValue ? (0, _formatMessage.default)({
        id: 'progress_display',
        default: '?',
        description: 'placeholder for an unknown percentage value'
      }) : this.formatPercentMax2FractionDigits(valueNow);
      return _react.default.createElement("div", {
        className: styles.scorePercentage,
        "data-automation": "sdk-quiz-score-percentage"
      }, valueToShow);
    }
  }, {
    key: "renderAlert",
    value: function renderAlert() {
      var _this$props = this.props,
          quizSessionResult = _this$props.quizSessionResult,
          sessionItemResults = _this$props.sessionItemResults;
      var ungradedCount = sessionItemResults.reduce(function (count, sessionItemResult) {
        return sessionItemResult.getIn(['scoredData', 'gradeStatus']) === 'waiting' ? count + 1 : count;
      }, 0);
      var hasUngradedQuesitons = ungradedCount > 0;
      var alerts = [];

      if (quizSessionResult.isLoaded() && quizSessionResult.autogradingFailed()) {
        var msg = (0, _formatMessage.default)('There was a grading problem. Please inform your instructor.');
        alerts.push(_react.default.createElement(_uiAlerts.Alert, {
          key: "autograding_failed",
          variant: "warning"
        }, msg));
      }

      if (hasUngradedQuesitons && quizSessionResult.isLoaded()) {
        var ungradedText = (0, _formatMessage.default)("{\n        count, plural,\n        one {# question requires grading}\n        other {# questions require grading}\n      }", {
          count: ungradedCount
        });
        alerts.push(_react.default.createElement(_uiAlerts.Alert, {
          key: "manual_grading",
          variant: "info"
        }, ungradedText));
      }

      if (alerts.length) {
        return _react.default.createElement("div", {
          className: styles.alertWrapper
        }, _react.default.createElement("div", {
          className: styles.alertWidth,
          "data-automation": "sdk-results-requires-grading"
        }, alerts));
      }
    }
  }, {
    key: "renderScoreStats",
    value: function renderScoreStats() {
      return _react.default.createElement("div", {
        className: styles.scoreStats
      }, this.renderProgress(), this.renderPointsDisplay());
    }
  }, {
    key: "renderProgress",
    value: function renderProgress() {
      if (this.pointsMissing || this.pointsPossibleMissing) {
        return null;
      }

      return _react.default.createElement("div", {
        className: styles.score,
        "data-automation": "sdk-info-score"
      }, _react.default.createElement(_uiElements.Progress, {
        animateOnMount: true,
        size: "large",
        variant: "circle",
        label: (0, _formatMessage.default)('Your Score'),
        formatValueText: this.progressTextFormatter,
        formatDisplayedValue: this.progressDisplayFormatter,
        valueNow: this.percentageVal,
        valueMax: 1
      }));
    }
  }, {
    key: "renderPointsDisplay",
    value: function renderPointsDisplay() {
      return _react.default.createElement("div", {
        className: styles.infoWrapper
      }, _react.default.createElement(_uiA11y.AccessibleContent, {
        alt: this.pointsText
      }, _react.default.createElement(_uiElements.Text, {
        as: "div",
        color: "primary",
        size: "xx-large",
        weight: "bold"
      }, this.mainPointsText), _react.default.createElement(_uiElements.Text, {
        color: "secondary"
      }, this.subPointsText)));
    }
  }, {
    key: "renderTime",
    value: function renderTime() {
      var attemptText = (0, _formatMessage.default)('Time for this attempt');
      var alt = (0, _formatMessage.default)('Time for this attempt: { time }', {
        time: (0, _formatTimespan.formatTime)(this.props.quizSession.elapsedTime)
      });
      return _react.default.createElement(_uiA11y.AccessibleContent, {
        alt: alt
      }, _react.default.createElement(_uiLayout.View, {
        as: "div"
      }, _react.default.createElement(_FormattedDuration.default, {
        fontSize: "xx-large",
        fontWeight: "bold",
        seconds: this.props.quizSession.elapsedTime
      })), _react.default.createElement(_uiElements.Text, {
        color: "secondary"
      }, attemptText));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, this.renderAlert(), _react.default.createElement("div", {
        className: styles.wrapper
      }, _react.default.createElement("div", {
        className: styles.info
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, _react.default.createElement(_uiElements.Heading, {
        level: "h2"
      }, (0, _formatMessage.default)('Assessment Statistics'))), this.renderScoreStats(), _react.default.createElement("div", {
        className: styles.infoWrapper
      }, this.renderTime()))));
    }
  }, {
    key: "points",
    get: function get() {
      return this.props.quizSessionResult.score;
    }
  }, {
    key: "pointsPresent",
    get: function get() {
      return typeof this.points === 'number';
    }
  }, {
    key: "pointsMissing",
    get: function get() {
      return !this.pointsPresent;
    }
  }, {
    key: "pointsPossible",
    get: function get() {
      return this.props.quizSessionResult.pointsPossible;
    }
  }, {
    key: "pointsPossiblePresent",
    get: function get() {
      return typeof this.pointsPossible === 'number';
    }
  }, {
    key: "pointsPossibleMissing",
    get: function get() {
      return !this.pointsPossiblePresent;
    }
  }, {
    key: "percentageVal",
    get: function get() {
      var ratio = this.props.quizSessionResult.percentage;
      return isNaN(ratio) ? unknownPercentageValue : ratio;
    }
  }, {
    key: "mainPointsText",
    get: function get() {
      if (this.pointsMissing && this.pointsPossibleMissing) {
        return '--';
      }

      var valueToUse = this.pointsPresent ? this.points : this.pointsPossible;
      return _formatMessage.default.number(valueToUse);
    }
  }, {
    key: "subPointsText",
    get: function get() {
      if (this.pointsPresent && this.pointsPossiblePresent) {
        return (0, _formatMessage.default)("Out of {\n        points, plural,\n        one {# point}\n        other {# points}\n      }", {
          points: this.pointsPossible
        });
      }

      if (this.pointsPresent) {
        return (0, _formatMessage.default)("Earned {points, plural,\n        one {point}\n        other {points}\n      }", {
          points: this.points
        });
      } // We use "Points Possible" when only points is present or when nothing is present


      return (0, _formatMessage.default)("{points, plural,\n      one {Point}\n      other {Points}\n    } possible", {
        points: this.pointsPossible
      });
    }
  }, {
    key: "pointsText",
    get: function get() {
      if (this.pointsPresent && this.pointsPossiblePresent) {
        return (0, _formatMessage.default)("{points, number} out of {\n        total, plural,\n        one {# point}\n        other {# points}\n      }", {
          points: this.points,
          total: this.pointsPossible
        });
      }

      if (this.pointsPresent) {
        return (0, _formatMessage.default)("Earned {points, plural,\n        one {# point}\n        other {# points}\n      }", {
          points: this.points
        });
      } // We use "Points Possible" when only points is present or when nothing is present


      if (this.pointsPossiblePresent) {
        return (0, _formatMessage.default)("{points, plural,\n        one {# point}\n        other {# points}\n      } possible", {
          points: this.pointsPossible
        });
      }

      return (0, _formatMessage.default)('Unknown Score');
    }
  }]);
  Info.displayName = "Info";
  return Info;
}((0, _quizCommon.withI18nSupport)(_react.Component)), _class2.propTypes = {
  quizSession: _reactImmutableProptypes.default.record.isRequired,
  quizSessionResult: _reactImmutableProptypes.default.record.isRequired,
  sessionItemResults: _reactImmutableProptypes.default.list.isRequired
}, _temp)) || _class);
exports.default = Info;