"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _quizCommon = require("@instructure/quiz-common");

var toggle = function toggle(state, key) {
  return state.update(key, function (value) {
    return !value;
  });
};

var defaultState = (0, _immutable.fromJS)({});

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : defaultState;
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _quizCommon.CLEAR_UI:
      return state.delete(action.payload);

    case _quizCommon.MERGE_UI:
      return state.mergeDeepIn([action.payload.key], action.payload.value);

    case _quizCommon.SET_UI:
      return state.set(action.payload.key, action.payload.value);

    case _quizCommon.TOGGLE_UI:
      return toggle(state, action.payload);

    case _quizCommon.OCCLUDE_QUIZ_ENTRIES:
      return state.set('quizEntriesOccluded', action.payload);

    case _quizCommon.ACTIVE_BANK_CHANGE:
      return state.set('activeBankId', action.payload);

    case _quizCommon.ACTIVE_BANK_ENTRY_CHANGE:
      return state.set('activeBankEntryId', action.payload);

    default:
      return state;
  }
};

exports.default = _default;